-- name: [CS] Luma
-- description: Ready to help you again.  By Alestar24\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local TEXT_MOD_NAME = ""
local TEXT_MOD_VERSION = "1.0"
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local TEX_LUMAICON = get_texture_info("lumaicon")

local VOICETABLE_LUMA = {
    [CHAR_SOUND_ATTACKED] = 'Luma-hit.ogg',
    [CHAR_SOUND_DOH] = 'Luma-hit.ogg',
    [CHAR_SOUND_DROWNING] = 'Luma-death.ogg',
    [CHAR_SOUND_DYING] = 'Luma-death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Luma-secjump.ogg',
    [CHAR_SOUND_HAHA] = 'Luma-1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'Luma-1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Luma-1up.ogg',
    [CHAR_SOUND_HOOHOO] = 'Luma-secjump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Luma-death.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Luma-1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Luma-hothothot.ogg',
    [CHAR_SOUND_OOOF] = 'Luma-hit.ogg',
    [CHAR_SOUND_OOOF2] = 'Luma-hit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Luma-kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Luma-secjump.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Luma-secjump.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Luma-1up.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Luma-1up.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Luma-secjump.ogg',
    [CHAR_SOUND_WAH2] = 'Luma-kick.ogg',
    [CHAR_SOUND_WHOA] = 'Luma-hit.ogg',
    [CHAR_SOUND_YAHOO] = 'Luma-wahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Luma-wahoo.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'Luma-jump.ogg',
    [CHAR_SOUND_YAWNING] = 'Luma-death.ogg',
}







-- Load Models
local E_MODEL_LUMAST = smlua_model_util_get_id("Lumast_geo")
local E_MODEL_LUMAREC = smlua_model_util_get_id("Lumarec_geo")
local E_MODEL_LUMALEEST = smlua_model_util_get_id("Lumaleest_geo")
local E_MODEL_LUMALEEREC = smlua_model_util_get_id("Lumaleerec_geo")



-- Character Initialize
local CT_LUMA64 = _G.charSelect.character_add("Luma", "Ready to help you again! (Press left or right to change Luma)", "Alestar24", {r = 220, g = 200, b = 0}, E_MODEL_LUMAST, CT_MARIO, TEX_LUMAICON)

-- Add Voices and Palette
_G.charSelect.character_add_voice(E_MODEL_LUMAST, VOICETABLE_LUMA)
_G.charSelect.character_add_voice(E_MODEL_LUMAREC, VOICETABLE_LUMA)
_G.charSelect.character_add_voice(E_MODEL_LUMALEEST, VOICETABLE_LUMA)
_G.charSelect.character_add_voice(E_MODEL_LUMALEEREC, VOICETABLE_LUMA)


-- Update Voicelines
local character_get_voice, update_sound, update_snore = _G.charSelect.character_get_voice, _G.charSelect.voice.sound, _G.charSelect.voice.snore
local function character_sounds(m, sound)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_LUMA
    then
        return update_sound(m, sound)
    end
end
local function character_snore(m)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_LUMA
    then
        return update_snore(m)
    end
end

hook_event(HOOK_CHARACTER_SOUND, character_sounds)
hook_event(HOOK_MARIO_UPDATE, character_snore)

--------------------------------------------
--- Alt Costume code from Paper Partners ---
--- By Squishy ---
--------------------------------------------

local character_edit = _G.charSelect.character_edit
local character_get_current_number = _G.charSelect.character_get_current_number
local character_get_current_table = _G.charSelect.character_get_current_table
local get_options_status = _G.charSelect.get_options_status
local get_menu_color = _G.charSelect.get_menu_color
local hook_render_in_menu = _G.charSelect.hook_render_in_menu

local table_insert = table.insert
local play_sound = play_sound
local djui_hud_get_screen_width = djui_hud_get_screen_width
local djui_hud_measure_text = djui_hud_measure_text
local djui_hud_set_color = djui_hud_set_color
local djui_hud_set_resolution = djui_hud_set_resolution
local djui_hud_set_rotation = djui_hud_set_rotation
local djui_hud_set_font = djui_hud_set_font
local djui_hud_print_text = djui_hud_print_text
local djui_hud_render_rect = djui_hud_render_rect
local maxf = maxf
local math_min = math.min
local math_max = math.max
local math_sin = math.sin

local altCostumes = {
    [CT_LUMA64] = {
        currSkin = 1,
        {name = "Standard", model = E_MODEL_LUMAST,},
        {name = "Rec. Eyes", model = E_MODEL_LUMAREC,},
        {name = "Lumalee", model = E_MODEL_LUMALEEST,},
        {name = "Lumalee Rec. Eyes", model = E_MODEL_LUMALEEREC,},

    },

}

local function update_character_skin(currChar, currAlt)
    local currSkin = altCostumes[currChar][currAlt]
    if altCostumes[currChar].desc == nil then
        altCostumes[currChar].desc = character_get_current_table().description
    end
    local description = {}
    for i = 1, #altCostumes[currChar].desc do
        table_insert(description, altCostumes[currChar].desc[i])
    end
    if currSkin.name ~= "" then
        table_insert(description, "")
        table_insert(description, "Current Outfit: "..currSkin.name)
    end
    character_edit(currChar, nil, description, nil, nil, currSkin.model, nil, nil)
    local cameraToObject = gMarioStates[0].marioObj.header.gfx.cameraToObject
    play_sound(SOUND_MENU_MESSAGE_NEXT_PAGE, cameraToObject)
end

local inputLockTimer = 0
local buttonAnimTimer = 0

local MATH_DIVIDE_320 = 1/320

local latencyValueTable = {12, 6, 3}

local function hud_render()
    local width = djui_hud_get_screen_width() + 1.4
    local widthScale = maxf(width, 321.4) * MATH_DIVIDE_320
    local currChar = character_get_current_number()
    local charColors = character_get_current_table().color
    
    -- Mimick button swaying, which is missing from the paper code
    local buttonAnim = 0
    local charSelectAnim = get_options_status(_G.charSelect.optionTableRef.anims)
    if charSelectAnim > 0 then
        buttonAnimTimer = buttonAnimTimer + 1
        buttonAnim = math_sin(buttonAnimTimer * 0.05) * 2.5 + 5
    else
        buttonAnim = 10
    end

    local inputLockTimerTo = latencyValueTable[get_options_status(_G.charSelect.optionTableRef.inputLatency) + 1]

    if altCostumes[currChar] ~= nil then
        -- Render Mod Variond under CS version
        local menuColor = get_menu_color()
        djui_hud_set_color(menuColor.r, menuColor.g, menuColor.b, 255)
        djui_hud_set_font(FONT_TINY)
        local string = TEXT_MOD_NAME.." ("..TEXT_MOD_VERSION..")"
        djui_hud_print_text(string, width - 5 - djui_hud_measure_text(string)*0.5, 3, 0.5)

        ---@type Controller
        local c = _G.charSelect.controller
        local currAlts = altCostumes[currChar]

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local inputLockTimerAnim = 0

        local buttonX = 20 * widthScale + buttonAnim
        local x1 = buttonX - 4
        local x2 = x1 + 73
        local y = 97

        if charSelectAnim > 0 then
            inputLockTimerAnim = inputLockTimer/inputLockTimerTo * 3
            x1 = x1 + math_min(inputLockTimerAnim, 0)
            x2 = x2 + math_max(inputLockTimerAnim, 0)
        end
        -- Left Arrow
        if currAlts.currSkin > 1 then
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x1, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x1 + 2.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                currAlts.currSkin = math_max(currAlts.currSkin - 1, 1)
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = -inputLockTimerTo
            end
        end
        -- Right Arrow
        if currAlts.currSkin < #currAlts then
            -- Changed arrows to mimick the ones seen in the options menu
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x2, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x2 - 3.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX + 69, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                currAlts.currSkin = currAlts.currSkin + 1
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = inputLockTimerTo
            end
        end
        -- use an input lock to prevent cycling too fast
        if inputLockTimer > 0 then
            inputLockTimer = inputLockTimer - 1
        elseif inputLockTimer < 0 then
            inputLockTimer = inputLockTimer + 1
        end
    end
end

hook_render_in_menu(hud_render)
